// WinTest.cpp : AvP[Vp̃Gg |Cg̒`
//
#include "stdafx.h"
#include "defwin.h"
#include "draw.h"
#include "key.h"
char Map[20*15+1]={//z
	"00000000000000000000"
	"00001111000000000000"
	"00001000000000001100"
	"00001100000000000000"
	"00000000000000000000"
	"00000000011011110000"
	"00000000000000000000"
	"00000000000000000000"
	"00011000000000000000"
	"00000100000000010000"
	"00000100001000000000"
	"00001000000000000000"
	"01000000000000000001"
	"01101000000000100000"
	"00000000000000111100"
};
class MyProg : public CSystem,CDraw
{
public:
	CJoyStick joy;
	void OnChar(int ch)
	{
		if(ch==27)//ESC
			Exit();//I
	}
	void Init()
	{
		SetHWND(GetHWND());
		SetWindowSize(320,240);
		SetScreen(320,240,24,1);
		SetSpriteMode(1);
		BoxFill(0,0,100,100,RGB(255,0,0),0);
		BoxFill(100,0,100,100,RGB(0,255,0),0);
		joy.SetClip(0,0,320-32,240-32);
	}
	void PutMap()
	{//wi̕\
		for(int y=0;y<15;++y){
			for(int x=0;x<20;++x){
				if(Map[x+y*20]-'0')
					BoxFill(x*16,y*16,15,15,RGB(0,0,255));
				else
					BoxFill(x*16,y*16,15,15,RGB(0,0,0));
			}
		}
	}
	int IsChipHit(int x,int y)
	{//x,yʒũ`bv𒲂ׂB
		int x2=(x+15)/16;
		int y2=(y+15)/16;
		int x1=x/16;//`bvPʂ̍Wɕϊ
		int y1=y/16;
		if(x1>=0 && x1<20 && y1>=0 && y1<15){//ꉞNbsO
			return (Map[x1+y1*20]-'0') | (Map[x1+y2*20]-'0')
				| (Map[x2+y1*20]-'0') | (Map[x2+y2*20]-'0');
		}
		return 0;
	}
	void Run()
	{
		char moji[256];
		int x1=0,y1=50,x2=100,y2=100;//ʒu
		int hit=0;
		int sx1=32,sy1=32,sx2=64,sy2=32;//TCY
		int x1_old,y1_old;
		SetSprite(0,0,0,sx1,sy1);//L̃p^[`
		SetSprite(1,100,0,sx2,sy2);//
		PutMap();
		ShowBench(1);
		for(;;){
			x1_old=x1;y1_old=y1;
			joy.Move(joy.GetStick(),x1,y1);//L[
			//
			wsprintf(moji,"x1=%3d y1=%3d hit=%d",x1,y1,hit);
			DrawText(moji,0,0,RGB(0,0,255),16,DRAW_SELECT,0);
			//
			hit=0;
			if(IsChipHit(x1,y1) || IsChipHit(x1+16,y1) || IsChipHit(x1,y1+16) || IsChipHit(x1+16,y1+16)){
				hit=1;
				x1=x1_old;y1=y1_old;
			}
			//
			PutSprite(0,x1,y1,0);
		//	PutSprite(1,x2,y2,1);
			UpDate();
			FrameWait(60);
		}
	}
};
MyProg p;
/*
			unsigned int a1=((x1-x2) & (x2-(x1+sx1))) | ((x2-x1) & (x1-(x2+sx2)));
			unsigned int a2=((y1-y2) & (y2-(y1+sy1))) | ((y2-y1) & (y1-(y2+sy2)));
			unsigned int a3=a1 & a2;
			if( a3>>31)
				hit=1;

			if((x1<x2 && (x1+sx1)>x2) || (x2<x1 && (x2+sx2)>x1)){
				if((y1<y2 && (y1+sy1)>y2) || (y2<y1 && (y2+sy2)>y1)){
					//
					hit=1;
				}
			}
*/