#include "stdafx.h"
#include"base.h"
#define MAX_CLS 30
static int clsCount=0;
static HWND clshWnd[MAX_CLS]={0};
static HANDLE clsHandle[MAX_CLS]={0};
int CBaseWnd::Add(HWND h,HANDLE clsPtr)
{
	if(IsWindow(h)){
		Sort();
		if(clsCount<MAX_CLS){
			clshWnd[clsCount]=h;
			clsHandle[clsCount]=clsPtr;
			clsCount++;
			return TRUE;
		}
	}
	return FALSE;
}
HANDLE CBaseWnd::GetHWND2Ptr(HWND h)
{
	for(int a=0;a<MAX_CLS;++a){
		if(clshWnd[a]==h)
			return clsHandle[a];
	}
	return NULL;
}
HWND CBaseWnd::GetPtr2HWND(HANDLE ptr)
{
	for(int a=0;a<MAX_CLS;++a){
		if(clshWnd[a]==ptr)
			return (HWND)clsHandle[a];
	}
	return NULL;
}
CBaseWnd::CBaseWnd(HWND h,HANDLE clsPtr)
{
	if(h!=NULL && clsPtr!=NULL)
		Add(h,clsPtr);
	else
		Sort();
}

CBaseWnd::~CBaseWnd()
{

}

HWND CBaseWnd::Get(int num)
{
	if(num>=0 && num<=clsCount){
		return clshWnd[num];
	}else{
		return NULL;
	}
}
void CBaseWnd::Sort()
{
	for(int b=0;b<MAX_CLS;++b){
		if(IsWindow(clshWnd[b])==0){
			clshWnd[b]=NULL;
			clsHandle[b]=NULL;
		}
	}
	clsCount=0;
	for(int a=0;a<MAX_CLS-1;++a){
		if(clshWnd[a]==NULL || clsHandle[a]==NULL){
			for(int b=a+1;b<MAX_CLS;++b){
				clshWnd[a]=clshWnd[b];
				clsHandle[a]=clsHandle[b];
				clshWnd[b]=NULL;
				clsHandle[b]=NULL;
			}
		}else{
			clsCount++;
		}
	}
}